/*
Si realizzi una funzione il cui prototipo e':
int potenza(float base, int esponente, float *risultato);
per calcolare la potenza di un numero reale con esponente intero positivo
(se l'esponente e' nullo il risultato sara' 1 per definizione). La funzione
restituisce il valore calcolato tramite il parametro formale "risultato"
passato per indirizzo ed utilizza il valore intero di ritorno per segnalare
eventuali errori: 0 indica che la funzione non ha dato errori, -1 indica una
condizione d'errore, ad esempio l'esponente negativo.

Come per l'esercizio precedente si realizzi un programma che permetta di
testare il corretto funzionamento della funzione prodotta.
*/

#include <stdio.h>
int pot(float base, int esp, float *ris);

int main()
{
   int e, ritorno;
   float b, ris;
   /* Descrizione funzionalit del programma */
   printf("Programma che calcola la\npotenza di un numero reale\ncon esponente intero positivo\n\n");

   do{ /* Acquisizione dati */
      b = 0;
	  ris = 1;
	  printf("Inserire il valore della base: (0 per terminare)\n");
      scanf("%f",&b);
      printf("Inserire il valore dell' esponente:\n");
      scanf("%d",&e);

	  /* Chiamata funzione */
      ritorno=pot(b, e, &ris);

	  /* Stampa risultato */
      if (ritorno==0)
         printf("Il risultato e' %.2f\n\n", ris);
      else
         printf("Errore!!!\n\n");
   //printf("Ritorno funzione %d\n\n", ritorno);
   }while(b!=0);

return 0;
}


int pot(float base, int esp, float *ris)
{
if(esp>=0){
   if (esp==0)
      *ris = 1;
   else
      for(;esp>0;esp--)
         *ris = *ris*base;
   return 0;
   }
else //if(esp<0)
   return -1;
}
