/*
Si realizzi una funzione C che, operando su una matrice di numeri interi
distinti passata come parametro, restituisca tre parametri interi relativi
all'eventuale punto di sella della matrice:
- parametro intero di valore 0 se la matrice non contiene punti di sella
  oppure di valore 1 se contiene un punto di sella
- riga del punto di sella
- colonna del punto di sella.
Si ricorda che il punto di sella di una matrice di numeri interi distinti e'
l'elemento minimo della riga a cui appartiene e massimo della colonna a cui
appartiene.
Se tale numero esiste e' unico.
*/


#include <stdio.h>

#define FALSO 0
#define VERO  1
#define RIGHE 4
#define COLONNE 3

void sel(int [][COLONNE], int);
void printMat(int [][COLONNE], int);

int main()
{
   int prova1[RIGHE][COLONNE] = { {33,7,71}, {19, 12, 83}, {29, 4, 15}, {39, 2 , 91} };
   int prova2[RIGHE][COLONNE] = { {5,17,9}, {91, 4, 19}, {83, 12, 7}, {6, 20 , 33} };

/* COMPLETARE IL MAIN PER TESTARE IL CORRETTO FUNZIONAMENTO DELLA FUNZIONE SULLE MATRICI
   FORNITE COME PROVA */

   printf("Matrice 1 e':\n\n");

   printMat(prova1, RIGHE);

   sel(prova1, RIGHE);

   printf("\n\nMatrice 2 e':\n\n");

   printMat(prova2, RIGHE);

   sel(prova2, RIGHE);


   return 0;
}

void sel(int pro[][COLONNE], int RIG){
	int i, j, max;

	for(j=0; j<RIG; j++)
		for (i=0; i<COLONNE; i++){
			max=pro[i][j];
			if(pro[i][j]<pro[i][j+1])
				max=pro[i][j+1];
		}
		printf("%d", max);
	return;
}


void printMat(int pro[][COLONNE], int RIG){
	int i, j;

	for(j=0; j<RIG; j++){
		for (i=0; i<COLONNE; i++){
			printf("%d\t", pro[j][i]);
		}
		printf("\n");
    }
	return;
}

