/*
Si realizzi una funzione che riceva come parametro di ingresso un array
bidimensionale temperature[2][31] contenente i giorni del mese e le rispettive
temperature ed un numero che rappresenta un mese dell'anno. La funzione deve
effettuare un ordinamento crescente delle temperature.

N.B.: il nome del mese viene passato per determinare quanti giorni prendere
in considerazione.
Si trascuri la gestione degli anni bisestili.
*/

#include <stdio.h>

#define DIM 2
#define GIORNI 31
void ordinaTemperature(float [][GIORNI], int);

int main()
{
   float temperature1[DIM][GIORNI] = {
   {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31},
   {2.3, 2.1, 2.5, 2.6, 2.5, 2.6, 2.7, 2.8, 2.6, 3.0, 2.6, 3.2, 3.5, 3.6, 3.7, 3.9, 2.9, 3.5, 4.0, 4.2, 4.3, 4.5, 5.0, 5.2, 5.4, 5.1, 5.6, 5.7, 5.8, 6.3, 4.5}
   };

   float temperature2[DIM][GIORNI] = {
   {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28},
   {3.3, 3.1, 3.2, 3.4, 2.9, 2.8, 2.7, 2.6, 3.0, 3.2, 3.4, 3.5, 3.6, 3.7, 3.9, 3.8, 3.3, 3.8, 4.0, 4.1, 4.2, 4.5, 4.3, 4.1, 3.8, 3.6, 3.2, 2.8}
   };

   int i;


   /* Temperature di Gennaio */
   printf("Temperature di Gennaio ordinate per giorno:\n");
   for(i=0; i<GIORNI; i++)
      printf("%2.f %5.2f        ", temperature1[0][i], temperature1[1][i]);
   printf("\n\n");

   ordinaTemperature(temperature1, GIORNI); /*Chiamata funzione*/

/* AGGIUNGERE LA CHIAMATA ALLA FUNZIONE PASSANDO L'ARRAY temperature1 RELATIVO
   ALLE TEMPERATURE DI Gennaio */

   printf("Temperature di Gennaio ordinate per valori decrescenti:\n");
   for(i=0; i<GIORNI; i++)
      printf("%2.f %5.2f        ", temperature1[0][i], temperature1[1][i]);
   printf("\n\n");

   printf("\nPremere Invio per continuare\n");
   scanf("%*c");

   /* Temperature di Febbraio */
   printf("Temperature di Febbraio ordinate per giorno:\n");
   for(i=0; i<28; i++)
      printf("%2.f %5.2f        ", temperature2[0][i], temperature2[1][i]);
   printf("\n\n");

   ordinaTemperature(temperature2, 28); /*Chiamata funzione*/

/* AGGIUNGERE LA CHIAMATA ALLA FUNZIONE PASSANDO L'ARRAY temperature2 RELATIVO
   ALLE TEMPERATURE DI Febbraio */

   /* Scrittura dell'array  */
   printf("Temperature di Febbraio ordinate per valori decrescenti:\n");
   for(i=0; i<28; i++)
      printf("%2.f %5.2f        ", temperature2[0][i], temperature2[1][i]);
   printf("\n\n");

   printf("\nPremere Invio per continuare\n");
   scanf("%*c");

   return 0;
}

void ordinaTemperature(float temp[][GIORNI], int gior)
{
int i, j, gioMom;
float mom; /*Cella temporanea*/
for(i=0;i<gior-1; i++)
	for(j=i+1; j<gior; j++)
		if(temp[1][i]<temp[1][j]){
			mom=temp[1][i]; /*Scambia le temperature*/
			temp[1][i]=temp[1][j];
			temp[1][j]=mom;
			gioMom=temp[0][i]; /*Scambia di conseguenza i giorni*/
			temp[0][i]=temp[0][j];
			temp[0][j]=gioMom;
		}
	return;
}
